/**
 * @author Damian_Dziedzic_&_Mateusz_Koacz
 */
import java.awt.EventQueue;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.Calendar;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextPane;
import javax.swing.SwingConstants;
import javax.swing.border.EmptyBorder;
import javax.swing.filechooser.FileFilter;

/**
 * Main Class Gui creating window.
 */
public class Gui extends JFrame implements ActionListener {
	private static final long serialVersionUID = 1L;
	private JPanel contentPane;
	private JLabel lbl_File_Xml = new JLabel("XML path");
	private JButton btn_Xml = new JButton("Choose XML file");
	private JLabel lbl_File_Xsd = new JLabel("XSD path");
	private JButton btn_Xsd = new JButton("Choose XSD file");
	private static JButton btn_Validate = new JButton("Validate");
	private JLabel lbl_Namespace = new JLabel("");
	private JLabel lbl_Targetnamespce = new JLabel("");
	private JTextPane text_Pane = new JTextPane();
	private JFileChooser file_Choose = new JFileChooser();
	private File xml_File;
	private String schema_Path;
	private static boolean b1 = false, b2 = false;
	private final JPanel panel = new JPanel();
	private final JScrollPane scrollPane = new JScrollPane();
	private String console = "";

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {

		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Gui frame = new Gui();
					frame.setVisible(true);

				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public Gui() {
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 800, 515);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(new GridLayout(0, 1, 0, 0));

		contentPane.add(panel);
		panel.setLayout(new GridLayout(0, 1, 0, 0));
		panel.add(lbl_File_Xml);

		lbl_File_Xml.setHorizontalAlignment(SwingConstants.CENTER);
		panel.add(btn_Xml);
		panel.add(lbl_File_Xsd);
		lbl_File_Xsd.setHorizontalAlignment(SwingConstants.CENTER);
		panel.add(btn_Xsd);
		panel.add(btn_Validate);

		btn_Validate.setEnabled(false);
		panel.add(lbl_Namespace);

		lbl_Namespace.setHorizontalAlignment(SwingConstants.LEFT);
		panel.add(lbl_Targetnamespce);

		lbl_Targetnamespce.setHorizontalAlignment(SwingConstants.LEFT);
		btn_Validate.addActionListener(this);
		btn_Xsd.addActionListener(this);
		btn_Xml.addActionListener(this);
		contentPane.add(scrollPane);
		scrollPane.setViewportView(text_Pane);

	}

	/**
	 * Button action handler
	 */
	@Override
	public void actionPerformed(ActionEvent e) {

		if (e.getSource() == btn_Xml) {

			file_Choose.setFileFilter(new FileFilter() {

				@Override
				public String getDescription() {
					return "XML fileL (*.xml)";
				}

				@Override
				public boolean accept(File f) {
					if (f.isDirectory()) {
						return true;
					} else {
						return f.getName().toLowerCase().endsWith(".xml");
					}

				}
			});

			int option = file_Choose.showDialog(Gui.this, "Choose XML file");

			if (option == JFileChooser.APPROVE_OPTION) {
				xml_File = file_Choose.getSelectedFile();
				b1 = true;
				if (b1 && b2) {
					btn_Validate.setEnabled(true);
				}
				lbl_File_Xml.setText(xml_File.getPath());
			}

		} else if (e.getSource() == btn_Xsd) {

			file_Choose.setFileFilter(new FileFilter() {

				@Override
				public String getDescription() {
					return "XSD file (*.xsd)";
				}

				@Override
				public boolean accept(File f) {
					if (f.isDirectory()) {
						return true;
					} else {
						return f.getName().toLowerCase().endsWith(".xsd");
					}

				}
			});

			int option = file_Choose.showDialog(Gui.this, "Choose XSD file");

			if (option == JFileChooser.APPROVE_OPTION) {
				schema_Path = file_Choose.getSelectedFile().getPath();
				b2 = true;
				if (b1 && b2) {
					btn_Validate.setEnabled(true);
				}
				lbl_File_Xsd.setText(schema_Path);
			}

		} else if (e.getSource() == btn_Validate) {
			text_Pane.setText("");
			XsdSchemaValidator xsdSchemaValidator = new XsdSchemaValidator();
			try {
				xsdSchemaValidator.validate(xml_File, schema_Path);
				if (xsdSchemaValidator.error_Count() == 0) {
					lbl_Namespace.setText("Namespace: "
							+ xsdSchemaValidator.getNamespace());
					lbl_Targetnamespce.setText("TargetNamespace: "
							+ xsdSchemaValidator.getTargetNamespace());
					console = console + Calendar.getInstance().getTime() + "\n"
							+ xsdSchemaValidator.getList() + " File is Valid"
							+ " \n" + "XML file: " + xml_File.getAbsolutePath()
							+ "\n" + "XSD file: " + schema_Path + "\n\n";
					xsdSchemaValidator.clear();
					text_Pane.setText(console);

				} else {
					lbl_Namespace.setText("Namespace: "
							+ xsdSchemaValidator.getNamespace());
					lbl_Targetnamespce.setText("TargetNamespace: "
							+ xsdSchemaValidator.getTargetNamespace());
					console = console + Calendar.getInstance().getTime() + "\n"
							+ "XML file: " + xml_File.getAbsolutePath() + "\n"
							+ "XSD file: " + schema_Path + "\n"
							+ xsdSchemaValidator.getList() + "\n\n";
					xsdSchemaValidator.clear();
					text_Pane.setText(console);

				}
			} catch (MyException e2) {
				console = console + Calendar.getInstance().getTime() + "\n"
						+ "XML file: " + xml_File.getAbsolutePath() + "\n"
						+ "XSD file: " + schema_Path + "\n"
						+ xsdSchemaValidator.getList() + "\n\n";
				xsdSchemaValidator.clear();
				text_Pane.setText(console);
				b1 = false;
				b2 = false;
				btn_Validate.setEnabled(false);
			} catch (Exception e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();

			}
		}

	}
}
