/**
 * @author Damian_Dziedzic_&_Mateusz_Koacz
 */
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.util.LinkedList;
import java.util.List;

import org.w3c.dom.ls.LSInput;
import org.w3c.dom.ls.LSResourceResolver;

/**
 * Class implementing LSResourceResolver Used by schemaFactory to Resolve path
 * to include and imported files in schema
 */
public class ResourceResolver implements LSResourceResolver {
	private String Path;
	private List<String> namespace = new LinkedList<String>();
	private List<String> targetNamespace = new LinkedList<String>();
	private List<String> fileNotFound = new LinkedList<String>();

	/**
	 * implemented method
	 */
	public LSInput resolveResource(String type, String namespaceURI,
			String publicId, String systemId, String baseURI) {
		/**
		 * Creating InputStream
		 */
		InputStream resourceAsStream;
		namespace.add(type);
		targetNamespace.add(namespaceURI);
		
		try {
			/**
			 * Creating Path from which xsd was choosen
			 */
			String absolutePath = Path;
			String dPath = absolutePath.substring(0,
					absolutePath.lastIndexOf(File.separator));
			dPath += "//";
			/**
			 * set InputStream too value from path
			 */
			resourceAsStream = new FileInputStream(dPath + systemId);
			return new Input(publicId, systemId, resourceAsStream);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			fileNotFound.add(e.getMessage()+"\n");
			return null;
		}

	}

	/**
	 * Method to set Path to choosen file xsd
	 * 
	 * @param vPath
	 *            String with Path
	 */
	public void setPath(String vPath) {
		Path = vPath;
	}
	
	public List<String> getNamespace() {
		return namespace;
	}
	
	public List<String> getTargetNameSpace() {
		return targetNamespace;
	}
	public List<String> IOEx(){
		return  fileNotFound;
	}
	public void clear(){
		fileNotFound.clear();
	}

}